module exprandom

use definitions
use random

contains

!================================================================!
!= Exponentialy distributed random function. Needs ran1 routine =!
!=  and have ran1dist reserved. Only used for random distance   =!
!= Copyed from numerical recipes and tested			=!
!================================================================!

function expdev(idum,L)
implicit none
integer	:: idum
real	:: expdev,dum,L

do
 dum=ran1dist(idum)
 if(dum.eq.0.) then
 else
  exit
 endif
enddo

expdev=-log(dum)/L
return

end function expdev

!================================================================!
!= Linear random function for choosing starting energy.		=!
!=  The method for creating needed distributions learned from   =!
!=  numerical recipes. There was no linear function to copy.	=!
!================================================================!

function lindev(idum)
implicit none
integer	:: idum
real	:: lindev,dum

do
 dum=ran1E2(idum)
 if(dum.eq.0.) then
 else
  exit
 endif
enddo

lindev=sqrt(2*dum)
return

end function lindev

!================================================================!
! Copy of expdev, but used for absorption calculations		=!
!================================================================!

function expabs(idum,L)
implicit none
integer	:: idum
real	:: expabs,dum,L

do
 dum=ran1abs(idum)
 if(dum.eq.0.) then
 else
  exit
 endif
enddo

expabs=-log(dum)/L
return

end function expabs

end module exprandom
