module mainloop

use random
use io
use definitions
use exprandom
use ranphys
use moderator
use math
use geometry

contains

!================================================================!
!= Simulates puts all the elements together to produce a	=!
!=  simulation. Do loop is over interactions, imax is a failsafe=!
!=  in case of a neutron getting stuck				=!
!= If a neutron gets stuck the last ten position updates will be=!
!=  showed at runtime. If this is a problem, increase imax.	=!
!= This part of the program is visualized with the flowchart 	=!
!================================================================!

subroutine simulate
implicit none

do i=1,imax+1					!loop over neutron interaktioner

!  call saferun					! Saferun was used for debugging
  call posmod

  if (posstatus==1) then			! Neutron in simple safe box

	if (r_old(3).le.safezmax) then 	
	 call randirec(seed1,seed2)
	 call randist
	 call newpos(i)
	 tdist=tdist+dist
	 interact=interact+1
	else
	 call concavecheck
	  if (ccheck==1) then
	   if (cylinder_v==1) call intercylinder
	   if (cylinder_v==0) call intersphere
	   call distchange
	   call newpos2(i)
	  else
	   call randirec(seed1,seed2)
	   call randist
	   call newpos(i)
	   tdist=tdist+dist
	   interact=interact+1
	  endif
	endif

  else if (posstatus==2) then			! Neutron in simple box care zone
	call concavecheck			!  but not in the sphere
	if (ccheck==1) then
	  if (cylinder_v==1) call intercylinder
	  if (cylinder_v==0) call intersphere
	  call distchange
	  call newpos2(i)
	else
	  call randirec(seed1,seed2)
	  call randist
	  call newpos(i)
	  tdist=tdist+dist
	  interact=interact+1
	endif
	
  else if (posstatus==3) then			! Neutron in simple box care zone
	   if (cylinder_v==1) call intercylinder!  and in sphere void
	   if (cylinder_v==0) call intersphere
	call inorout
	if (ioru==1) then			! ioru=1 means in simple box
	  call distchange
	  call newpos2(i)
	else 					! out of simple box
	  n=n+1
	  call output(k,i)
	  l=l+1
	  l2=l2+1
	  exit
	endif

  else if (posstatus==4) then			! Neutron is not in simple box
	call interbox
	if (interside==6) then			! Neutron is outgoing
	  n=n+1
	  call output(k,i)
	  l=l+1
	  l2=l2+1
	  exit
!	else if (interside==1) then		! Neutron hit boundary, turns arround
!	  call mirror
!	  call newpos(i)
!	  boundary=boundary+1
!	  interact=interact+1
	else
	   m=m+1
	  if (m.le.mfactor*nmax) then
	   call outputm(k,i)
	   mmax=m
	   exit
	  else
	   exit
	  endif
	endif

  else if (stuck==1) then
	print*, 'neutron nr',k,'got stuck, no data'
	exit

  else
	print*, 'posstatus error'
	stop
  endif

  if (i.gt.imax-10) then
	print*,'******************************************'
	print*,'r_old=',r_old
	print*,'r    =',r
	print*,'******************************************'
  endif

  if (i==imax.or.stuck==1) then
	r(:)=0
	r_old(:)=0
	fail=1
	print*,'Neutron number',k,'failed',i,stuck
	call output(k,i)
	exit
  endif

 if (absorption==1.and.tdist.gt.tdistmax) then
  absorped=absorped+1
  exit
 endif

enddo

end subroutine simulate

!================================================================!
!= simulatetest is a copy of simulate with the first iteration 	=!
!=  done without random distance so the user can choose the 	=!
!=  first distance to create specific troublesome situations.	=!
!================================================================! 

subroutine simulatetest
implicit none
integer :: stopit

stopit = 0

i=1

if (absorption==1.and.tdist.gt.tdistmax) then
  absorped=absorped+1
  stopit=1
endif


!  call saferun
  call posmod

  if (posstatus==1) then			! Neutron in simple safe box

	if (r_old(3).le.safezmax) then 
	 call randirec(seed1,seed2)
	 call randist
	 call newpos(i)
	 tdist=tdist+dist
	 interact=interact+1
	else
	 call concavecheck
	  if (ccheck==1) then
	   if (cylinder_v==1) call intercylinder
	   if (cylinder_v==0) call intersphere
	   call distchange
	   call newpos2(i)
	  else
	   call randirec(seed1,seed2)
	   call randist
	   call newpos(i)
	   tdist=tdist+dist
	   interact=interact+1
	  endif
	endif

  else if (posstatus==2) then			! Neutron in simple box care zcyone
	call concavecheck			!  but not in the sphere
	if (ccheck==1) then
	  if (cylinder_v==1) call intercylinder
	  if (cylinder_v==0) call intersphere
	  call distchange
	  call newpos2(i)
	else
	  call randirec(seed1,seed2)
	  call randist
	  call newpos(i)
	  tdist=tdist+dist
	  interact=interact+1
	endif
	
  else if (posstatus==3) then			! Neutron in simple box care zone
	   if (cylinder_v==1) call intercylinder!  and in sphere void
	   if (cylinder_v==0) call intersphere
	call inorout
	if (ioru==1) then			! ioru=1 means in simple box
	  call distchange
	  call newpos2(i)
	else 					! out of simple box
	  n=n+1
	  call output(k,i)
	  l=l+1
	  l2=l2+1
	  stopit=1
	endif

  else if (posstatus==4) then			! Neutron is not in simple box
	call interbox
	if (interside==6) then			! Neutron is outgoing
	  n=n+1
	  call output(k,i)
	  l=l+1
	  l2=l2+1
	  stopit=1
!	else if (interside==1) then		! Neutron hit boundary, turn arround
!	  call mirror
!	  call newpos(i)
!	  boundary=boundary+1
!	  interact=interact+1
	else
	   m=m+1
	  if (m.le.mfactor*nmax) then
	   call outputm(k,i)
	   mmax=m
	   stopit=1
	  else
	   stopit=1
	  endif
	endif

  else if (stuck==1) then
	print*, 'neutron nr',k,'got stuck, no data'
	stopit=1

  else
	print*, 'posstatus error'
	stop
  endif

  if (i.gt.imax-10) then
	print*,'******************************************'
	print*,'r_old=',r_old
	print*,'r    =',r
	print*,'******************************************'
  endif

  if (i==imax.or.stuck==1) then
	r(:)=0
	r_old(:)=0
	fail=1
	print*,'Neutron number',k,'failed',i,stuck
	call output(k,i)
	stopit=1
  endif

do i=2,imax+1					!loop over neutron interaktioner

if (absorption==1.and.tdist.gt.tdistmax) then
  absorped=absorped+1
  exit
endif

!print*,'position    ',r(:)
!print*,'old position',r_old(:)

!  call saferun
  call posmod

  if (posstatus==1) then			! Neutron in simple safe box

	if (r_old(3).le.safezmax) then 
	 call randirec(seed1,seed2)
	 call randist
	 call newpos(i)
	 tdist=tdist+dist
	 interact=interact+1
	else
	 call concavecheck
	  if (ccheck==1) then
	   if (cylinder_v==1) call intercylinder
	   if (cylinder_v==0) call intersphere
	   call distchange
	   call newpos2(i)
	  else
	   call randirec(seed1,seed2)
	   call randist
	   call newpos(i)
	   tdist=tdist+dist
	   interact=interact+1
	  endif
	endif

  else if (posstatus==2) then			! Neutron in simple box care zcyone
	call concavecheck			!  but not in the sphere
	if (ccheck==1) then
	  if (cylinder_v==1) call intercylinder
	  if (cylinder_v==0) call intersphere
	  call distchange
	  call newpos2(i)
	else
	  call randirec(seed1,seed2)
	  call randist
	  call newpos(i)
	  tdist=tdist+dist
	  interact=interact+1
	endif
	
  else if (posstatus==3) then			! Neutron in simple box care zone
	   if (cylinder_v==1) call intercylinder!  and in sphere void
	   if (cylinder_v==0) call intersphere
	call inorout
	if (ioru==1) then			! ioru=1 means in simple box
	  call distchange
	  call newpos2(i)
	else 					! out of simple box
	  n=n+1
	  call output(k,i)
	  l=l+1
	  l2=l2+1
	  exit
	endif

  else if (posstatus==4) then			! Neutron is not in simple box
	call interbox
	if (interside==6) then			! Neutron is outgoing
	  n=n+1
	  call output(k,i)
	  l=l+1
	  l2=l2+1
	  exit
!	else if (interside==1) then		! Neutron hit boundary, turn arround
!	  call mirror
!	  call newpos(i)
!	  boundary=boundary+1
!	  interact=interact+1
	else
	   m=m+1
	  if (m.le.mfactor*nmax) then	
	   call outputm(k,i)
	   mmax=m
	   exit
	  else
	   exit
	  endif
	endif

  else if (stuck==1) then
	print*, 'neutron nr',k,'got stuck, no data'
	exit

  else
	print*, 'posstatus error'
	stop
  endif

  if (i.gt.imax-10) then
	print*,'******************************************'
	print*,'r_old=',r_old
	print*,'r    =',r
	print*,'******************************************'
  endif

  if (i==imax.or.stuck==1) then
	r(:)=0
	r_old(:)=0
	fail=1
	print*,'Neutron number',k,'failed',i,stuck
	call output(k,i)
	exit
  endif

enddo

end subroutine simulatetest

end module mainloop