module phys

use definitions

contains

!================================================================!
!= cross_section is a small database with the cross sections for=!
!=  neutron hydrogen collisions at different neutron energies.	=!
!= It is a 10th order taylor fit to data from NNDC		=!
!================================================================!


subroutine cross_section
implicit none
real :: E_temp, s_temp

E_temp = log10(E)

s_temp = - 1.2066E-007 * E_temp**(10)  &
         + 9.6423E-007 * E_temp**9     &
         + 9.7495E-006 * E_temp**8     &
         - 7.5128E-005 * E_temp**7     &
         - 0.00030864  * E_temp**6     &
         + 0.0021051   * E_temp**5     &
         + 0.0037625   * E_temp**4     &
         - 0.028526    * E_temp**3     &
         + 0.024864    * E_temp**2     &
         - 0.0023165   * E_temp        &
         + 1.3019

cross = (10**s_temp)*1E-22

end subroutine cross_section

end module phys
